﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.Linq.Architecture.NTier.DomainModel;
using System.Configuration;

namespace DevLeap.Linq.Architecture.NTier.DataLayer.LinqToSql
{
    // Listing 15-9

    public abstract class BaseDal<TEntity, TEntityList, TKey>: IDal<TEntity, TEntityList, TKey>
        where TEntity : BaseEntity, new()
        where TEntityList : IEnumerable<TEntity>
    {
        private NorthwindDataContext _northwind;

        protected NorthwindDataContext Northwind
        {
            get { return this._northwind; }
        }

        protected BaseDal()
        {
            _northwind = new NorthwindDataContext(ConfigurationManager.ConnectionStrings["Northwind"].ConnectionString);
            
            // For debugging and demo purposes only
            _northwind.Log = Console.Out;
        }

        #region IDal<TEntity,TEntityList,TKey> Members

        public virtual TEntity Add(TEntity item)
        {
            throw new NotImplementedException();
        }

        public virtual TEntity Read(TKey key)
        {
            throw new NotImplementedException();
        }

        public virtual TEntityList ReadAll()
        {
            throw new NotImplementedException();
        }

        public virtual TEntity Update(TEntity item)
        {
            throw new NotImplementedException();
        }

        public virtual bool Delete(TEntity item)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
