﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.Linq.Architecture.NTier.DomainModel;

namespace DevLeap.Linq.Architecture.NTier.DataLayer.LinqToSql
{
    public class LinqToSqlDalFactory: IDalFactory
    {
        #region IDalFactory Members

        public IDal<TEntity, TEntityList, TKey> CreateDal<TEntity, TEntityList, TKey>()
            where TEntity : BaseEntity, new()
            where TEntityList : IEnumerable<TEntity>
        {
            switch (typeof(TEntity).Name)
            { 
                case "Customer":
                    // return new VerboseCustomerDal() as IDal<TEntity, TEntityList, TKey>;
                    return new CustomerDal() as IDal<TEntity, TEntityList, TKey>;
                case "Order":
                    return new OrderDal() as IDal<TEntity, TEntityList, TKey>;
                default:
                    return null;
            }
        }

        #endregion
    }
}
