﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.Linq.Architecture.NTier.DomainModel;
using System.Configuration;
using System.Xml.Linq;

namespace DevLeap.Linq.Architecture.NTier.DataLayer.LinqToXml
{
    // Listing 15-14

    public abstract class BaseDal<TEntity, TEntityList, TKey>: IDal<TEntity, TEntityList, TKey>
        where TEntity : BaseEntity, new()
        where TEntityList : IEnumerable<TEntity>
    {
        private XElement _northwindXml;

        protected XElement NorthwindXml
        {
            get { return (this._northwindXml); }
        }

        protected BaseDal()
        {
            _northwindXml = XElement.Load(ConfigurationManager.AppSettings["XmlDataSourcePath"]);

        }

        protected void Save()
        {
            this.NorthwindXml.Save(ConfigurationManager.AppSettings["XmlDataSourcePath"]);
        }

        #region IDal<TEntity,TEntityList,TKey> Members

        public virtual TEntity Add(TEntity item)
        {
            throw new NotImplementedException();
        }

        public virtual TEntity Read(TKey key)
        {
            throw new NotImplementedException();
        }

        public virtual TEntityList ReadAll()
        {
            throw new NotImplementedException();
        }

        public virtual TEntity Update(TEntity item)
        {
            throw new NotImplementedException();
        }

        public virtual bool Delete(TEntity item)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
