﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;

namespace DevLeap.Linq.Architecture.NTier.DataLayer
{
    public static class DalFactory
    {
        private static IDalFactory instance;
        private static Object instanceSyncLock = new Object();

        public static IDalFactory Instance
        { 
            get 
            {
                if (instance == null)
                {
                    lock (instanceSyncLock)
                    {
                        if (instance == null)
                        {
                            String dalFactoryTypeName = ConfigurationManager.AppSettings["DalFactoryType"];
                            Type dalFactoryType = Type.GetType(dalFactoryTypeName, true);
                            instance = Activator.CreateInstance(dalFactoryType) as IDalFactory;
                        }
                    }
                }

                return (instance);
            }
        }
    }
}
