﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace DevLeap.Linq.CSharp.AnonymousTypes {
    class AnonymousTypes {
        static void Main() {
            Demo();
            DemoArray();
        }

        static void Demo() {
            // ------------------------------------------------------
            //
            // BEGIN Listing B-35
            //
            Customer c1 = new Customer { Name = "Marco" };
            var c2 = new Customer { Name = "Paolo" };
            var c3 = new { Name = "Tom", Age = 31 };
            var c4 = new { c2.Name, c2.Age };
            var c5 = new { c1.Name, c1.Country };
            var c6 = new { c1.Country, c1.Name };
            //
            // END    Listing B-35
            //
            // ------------------------------------------------------

            Console.WriteLine("c1 is {0}", c1.GetType());
            Console.WriteLine("c2 is {0}", c2.GetType());
            Console.WriteLine("c3 is {0}", c3.GetType());
            Console.WriteLine("c4 is {0}", c4.GetType());
            Console.WriteLine("c5 is {0}", c5.GetType());
            Console.WriteLine("c6 is {0}", c6.GetType());
        }

        static void DemoArray() {
            // ------------------------------------------------------
            //
            // BEGIN Listing B-36
            //
            var ints = new[] { 1, 2, 3, 4 };
            var ca1 = new[] {
                new Customer { Name = "Marco", Country = "Italy" },
                new Customer { Name = "Tom", Country = "USA" },
                new Customer { Name = "Paolo", Country = "Italy" }
            };
            var ca2 = new[] {
                new { Name = "Marco", Sports = new[] { "Tennis", "Spinning"} },
                new { Name = "Tom", Sports = new[] { "Rugby", "Squash", "Baseball" } },
                new { Name = "Paolo", Sports = new[] { "Skateboard", "Windsurf" } }
            };
            //
            // END    Listing B-36
            //
            // ------------------------------------------------------
            Console.WriteLine("ints is {0}", ints.GetType());
            Console.WriteLine("ca1 is {0}", ca1.GetType());
            Console.WriteLine("ca2 is {0}", ca2.GetType());
        }
    }

    public class Customer {
        public int Age;
        public string Name;
        public string Country;
        public Customer(string name, int age) {
            this.Name = name;
            this.Age = age;
        }
        public Customer() {
            Age = -1;
            Name = "<Unknown>";
            Country = "<Unknown>";
        }
    }

}