using System;
using System.Linq;

namespace DevLeap.Linq.CSharp.ExtensionMethods {

    static class LambdaUseExtension {
        // ------------------------------------------------------
        //
        // BEGIN Listing B-28
        //

        public static void Display<T>(this T[] names, Func<T, bool> filter) {
            foreach (T s in names) {
                if (filter(s)) Console.WriteLine(s);
            }
        }

        public static void Demo() {
            string[] names = { "Marco", "Paolo", "Tom" };
            names.Display(s => s.Length > 4);

            int[] ints = { 19, 16, 4, 33 };
            ints.Display(i => i % 2 == 0);
        }
        //
        // END    Listing B-28
        //
        // ------------------------------------------------------

    }
}