﻿using System;
using System.Collections.Generic;

namespace DevLeap.Linq.CSharp.LambdaExpressions {

    public class AggDelegate {
        public List<int> Values;
        public static void Demo() {
            AggDelegate l = new AggDelegate();
            int sum;
            sum = Aggregate(
                    l.Values,
                    delegate(int a, int b) { return a + b; }
                );
            Console.WriteLine("Sum = {0}", sum);
            int min;
            min = Aggregate(
                    l.Values,
                    delegate(int a, int b) { return (a < b) ? a : b; }
                );
            Console.WriteLine("Min = {0}", min);
        }
        public AggDelegate() {
            Values = new List<int>();
            Values.Add(10);
            Values.Add(20);
            Values.Add(30);
            Values.Add(40);
            Values.Add(50);
        }
        delegate int Func(int a, int b);
        static int Aggregate(List<int> l, Func f) {
            int result = 0;
            bool firstLoop = true;
            foreach (int value in l) {
                if (firstLoop) {
                    result = value;
                    firstLoop = false;
                }
                else {
                    result = f(result, value);
                }
            }
            return result;
        }
    }
}