﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace DevLeap.Linq.CSharp.LambdaExpressions {

    public class AggDelegateGeneric {
        public List<int> Values;
        public static void Demo() {
            AggDelegateGeneric l = new AggDelegateGeneric();
            int sum = Aggregate(l.Values,
                                 delegate(int a, int b) {
                                     return a + b;
                                 }
                            );
            Console.WriteLine("Sum = {0}", sum);
            int min = Aggregate(l.Values,
                                 delegate(int a, int b) {
                                     return (a < b) ? a : b;
                                 }
                            );
            Console.WriteLine("Min = {0}", min);

        }
        public AggDelegateGeneric() {
            Values = new List<int>();
            Values.Add(10);
            Values.Add(20);
            Values.Add(30);
            Values.Add(40);
            Values.Add(50);
        }
        delegate T Func<T>(T a, T b);
        static T Aggregate<T>(List<T> l, Func<T> f) {
            T result = default(T);
            bool firstLoop = true;
            foreach (T value in l) {
                if (firstLoop) {
                    result = value;
                    firstLoop = false;
                }
                else {
                    result = f(result, value);
                }
            }
            return result;
        }
        /*    
         * // THIS CODE DOES NOT COMPILE
         * // You cannot use operators with generic types
            T Sum<T>( T a, T b) {
                return a + b;
            }
        */
    }
}