using System;
using System.Linq;

namespace DevLeap.Linq.CSharp.LambdaExpressions {
    static class LambdaUse {
        // ------------------------------------------------------
        //
        // BEGIN Listing B-20
        //
        public static void Listing2_20() {
            string[] names = { "Marco", "Paolo", "Tom" };
            // We pass a predicate to filter strings to display
            Display(names, s => s.Length > 4);

            // This is a projection (not used in this sample)
            Func<string, int> f = (s) => s.Length;
        }

        public static void Display<T>(T[] names, Func<T, bool> filter) {
            foreach (T s in names) {
                if (filter(s)) Console.WriteLine(s);
            }
        }
        //
        // END    Listing B-20
        //
        // ------------------------------------------------------
    }

}