﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace DevLeap.Linq.CSharp.QueryExpressions {

    class QueryExpressions {
        static void Demo() {
            var customers = new[]{
            new {  Name = "Marco", Discount = 4.5 },
            new {  Name = "Paolo", Discount = 3.0 },
            new {  Name = "Tom", Discount = 3.5 }
        };
            var customers2 = new[]{
            new {  Name = "Marco", Boh = 4.5 },
            new {  Name = "Paolo", Boh = 3.0 },
            new {  Name = "Tom", Boh = 3.5 }
        };

            var query =
                from c in customers
                where c.Discount > 3
                orderby c.Discount
                select new { c.Name, Perc = c.Discount / 100 };

            foreach (var x in query) {
                Console.WriteLine(x);
            }
        }
        static void DemoExplicit() {
            var customers = new[]{
            new {  Name = "Marco", Discount = 4.5 },
            new {  Name = "Paolo", Discount = 3.0 },
            new {  Name = "Tom", Discount = 3.5 }
        };

            var query = customers
                        .Where(c => c.Discount > 3)
                        .OrderBy(c => c.Discount)
                        .Select(c => new { c.Name, Perc = c.Discount / 100 });

            foreach (var x in query) {
                Console.WriteLine(x);
            }
        }
        static void DemoCountdown() {
            Countdown cd = new Countdown();
            cd.StartCountdown = 5;
            var query = from n in cd
                        where n % 2 == 1
                        select n;
            foreach (var x in query) {
                Console.WriteLine(x);
            }
        }
        static void Main() {
            Demo();
            DemoExplicit();
            DemoCountdown();
        }
    }


    public class Countdown : IEnumerable<int> {
        public int StartCountdown;

        IEnumerator IEnumerable.GetEnumerator() {
            return this.GetEnumerator();
        }
        public IEnumerator<int> GetEnumerator() {
            for (int i = 0; i < StartCountdown; i++) {
                yield return i;
            }
        }
    }

}