﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DevLeap.FlightStatus {
    // 
    // Listing 12-25
    // 
    public class Flight {
        public string Airline { get; set; }
        public string FlightNumber { get; set; }
        public string Aircraft { get; set; }
        public AirportInformation Departure { get; set; }
        public AirportInformation Arrival { get; set; }
        public TimeSpan TimeToArrival { get; set; }
        public Position Position { get; set; }
        public int GroundSpeed { get; set; }
        public int Altitude { get; set; }

        public override string ToString() {
            return String.Format(
                "Flight {0}{1} ({2})\n"
                +"FROM: {3} Scheduled: {4}  Actual:    {5}\n"
                +"TO:   {6} Scheduled: {7}  Estimated: {8}\n"
                +"Time to arrival: {9}\n"
                +"Ground speed/Altitude: {10} KTS / {11} feet",
                Airline, FlightNumber, Aircraft,
                Departure.Airport, Departure.ScheduledTime, Departure.ActualTime,
                Arrival.Airport, Arrival.ScheduledTime, Arrival.ActualTime,
                TimeToArrival,
                GroundSpeed,
                Altitude);
        }
    }
}
