﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DevLeap.Linq.ExtendingLINQ.IQueryableInterface {
    class Program {
        static void Main(string[] args) {
            Console.WriteLine("---- EnumerableToQueryable ----");
            EnumerableToQueryable();
            Console.WriteLine("---- DumpIQueryable ----");
            DumpIQueryable();
            return;
        }
        static void EnumerableToQueryable() {
            // 
            // Listing 12-21
            // 
            int[] numbers = { 1, 2, 3, 5, 8, 13, 21 };
            IQueryable<int> query1 =
                from n in numbers.AsQueryable()
                where n % 2 == 0
                select n;
            IQueryable<int> query2 =
                (from n in numbers
                 where n % 2 == 0
                 select n).AsQueryable();
            Console.WriteLine(query1.ToString());
            Console.WriteLine(query2.ToString());
        }
        static void DumpIQueryable() {
            // 
            // Listing 12-22
            // 
            int[] numbers = { 1, 2, 3, 5, 8, 13, 21 };
            IQueryable<int> queryEven =
                from n in numbers.AsQueryable()
                where n % 2 == 0
                select n;
            Console.WriteLine("** queryEven **");
            Console.WriteLine("Provider Type = {0}", queryEven.Provider.GetType());
            Console.WriteLine("ElementType   = {0}", queryEven.ElementType);
            Console.WriteLine("Expression    = {0}", queryEven.Expression);

            IQueryable<int> queryNumbers = numbers.AsQueryable();
            Console.WriteLine("** queryNumbers **");
            Console.WriteLine("Provider Type = {0}", queryNumbers.Provider.GetType());
            Console.WriteLine("ElementType   = {0}", queryNumbers.ElementType);
            Console.WriteLine("Expression    = {0}", queryNumbers.Expression);
        }
        static void Dump<T>(IEnumerable<T> sequence) {
            foreach (T item in sequence) {
                Console.WriteLine(item);
            }
        }
    }
}
