﻿Option Strict On
Option Infer On
Module AnonymousTypes

    Sub Main()
        Demo()
        DemoArray()
        DemoComparison()
    End Sub

    Sub Demo()
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-18 
        '

        Dim c1 As New Customer With {.Name = "Marco"}
        Dim c2 = New Customer With {.Name = "Paolo"}
        Dim c3 = New With {.Name = "Tom", .Age = 31}
        Dim c4 = New With {c2.Name, c2.Age}
        Dim c5 = New With {c1.Name, c1.Country}
        Dim c6 = New With {c1.Country, c1.Name}

        '
        ' END Listing C-18
        '
        ' ------------------------------------------------------

        Console.WriteLine("c1 is {0}", c1.GetType())
        Console.WriteLine("c2 is {0}", c2.GetType())
        Console.WriteLine("c3 is {0}", c3.GetType())
        Console.WriteLine("c4 is {0}", c4.GetType())
        Console.WriteLine("c5 is {0}", c5.GetType())
        Console.WriteLine("c6 is {0}", c6.GetType())
    End Sub
    Sub DemoArray()


        'COMMENTED OUT BEGIN
        ' Dim ints = {1, 2, 3, 4}    ' This syntax will be supported in a future version of Visual Basic
        ' Array of customer
        Dim cc As Customer() = _
                 {New Customer With {.Name = "Marco", .Country = "Italy"}, _
                  New Customer With {.Name = "Tom", .Country = "USA"}, _
                  New Customer With {.Name = "Paolo", .Country = "Italy"}}

        ' The following syntax will be supported in a future version of Visual Basic
        'Dim ca = _
        '         {New With {.Name = "Marco", .Country = "Italy"}, _
        '          New With {.Name = "Tom", .Country = "USA"}, _
        '          New With {.Name = "Paolo", .Country = "Italy"}}

        'Dim cs = {New With {.Name = "Marco", .Sports = {"Tennis", "Spinning"}}, _
        '          New With {.Name = "Tom", .Sports = {"Rugby", "Squash", "Baseball"}}, _
        '          New With {.Name = "Paolo", .Sports = {"Skateboard", "Windsurf"}}}

        ' A workaround using helper function is possible
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-19
        '
        Dim ca = MakeArray( _
                  New With {.Name = "Marco", .Country = "Italy"}, _
                  New With {.Name = "Tom", .Country = "USA"}, _
                  New With {.Name = "Paolo", .Country = "Italy"})

        Console.WriteLine("ca is {0}", ca.GetType())
        '
        ' END Listing C-19
        '
        ' ------------------------------------------------------

        Dim cs = MakeArray( _
                  New With {.Name = "Marco", .Sports = MakeArray("Tennis", "Spinning")}, _
                  New With {.Name = "Tom", .Sports = MakeArray("Rugby", "Squash", "Baseball")}, _
                  New With {.Name = "Paolo", .Sports = MakeArray("Skateboard", "Windsurf")})


        'Console.WriteLine("ints is {0}", ints.GetType())
        Console.WriteLine("cc is {0}", cc.GetType())
        Console.WriteLine("cs is {0}", cs.GetType())

        'COMMENTED OUT END

    End Sub
    Function MakeArray(Of T)(ByVal ParamArray params As T()) As T()
        Return params
    End Function
    Sub DemoComparison()

        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-20 
        '
        Dim c7 = New With {.Name = "Marco", .Country = "USA"}
        Dim c8 = New With {Key .Name = "Marco", .Country = "USA"}
        c7.Country = "France"
        c7.Name = "Claude"
        c8.Country = "Italy"
        ' c8.Name = "Roberto" ' Compiler error - Name is read-only
        Console.WriteLine("c7 is {0}", c7.GetType())
        Console.WriteLine("c8 is {0}", c8.GetType())
        '
        ' END Listing C-20
        '
        ' ------------------------------------------------------

        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-21
        '
        Dim h1 = New With {.Name = "Marco", .Country = "USA"}
        Dim h2 = New With {.Name = "Marco", .Country = "Italy"}
        Dim h3 = New With {Key .Name = "Marco", .Country = "USA"}
        Dim h4 = New With {Key .Name = "Marco", .Country = "Italy"}
        Dim h5 = New With {Key .Name = "Marco", Key .Country = "USA"}
        Dim h6 = New With {Key .Name = "Marco", Key .Country = "Italy"}

        Console.WriteLine("h1 and h2 are {0}", If(h1.Equals(h2), "equals", "different"))
        Console.WriteLine("h3 and h4 are {0}", If(h3.Equals(h4), "equals", "different"))
        Console.WriteLine("h5 and h6 are {0}", If(h5.Equals(h6), "equals", "different"))

        '
        ' END Listing C-21
        '
        ' ------------------------------------------------------

    End Sub
End Module

Public Class Customer
    Public Age As Integer
    Public Name As String
    Public Country As String
    Public Sub New(ByVal name As String, ByVal age As Integer)
        Me.Age = age
        Me.Name = name
    End Sub
    Public Sub New()
        Age = -1
        Name = "<Unknown>"
        Country = "<Unknown>"
    End Sub

End Class
