﻿Module Closures
    Private Function _Lambda_2(ByVal customer As Customer) As String
        Return customer.Name
    End Function

    Sub Main2()
        Dim customers As Customer() = {New Customer() With {.Name = "Marco", .Sports = New String() {"Tennis", "Spinning"}}, _
                  New Customer() With {.Name = "Tom", .Sports = New String() {"Rugby", "Squash", "Baseball"}}, _
                  New Customer() With {.Name = "Paolo", .Sports = New String() {"Skateboard", "Windsurf"}}}
        ' The following two lines corresponds the "Dim maxPlayers = 2" line
        Dim _ClosureVariable As New _Closure
        _ClosureVariable._maxPlayers = 2

        Dim players = _
            Enumerable.Select( _
                Enumerable.Where(customers, _
                    AddressOf _ClosureVariable._Lambda_1), _
                    AddressOf _Lambda_2)
        '...
    End Sub

    Sub Main()

        Dim customers As Customer() = {New Customer() With {.Name = "Marco", .Sports = New String() {"Tennis", "Spinning"}}, _
                  New Customer() With {.Name = "Tom", .Sports = New String() {"Rugby", "Squash", "Baseball"}}, _
                  New Customer() With {.Name = "Paolo", .Sports = New String() {"Skateboard", "Windsurf"}}}

        Dim maxPlayers = 2

        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-28
        '
        Dim players = _
            From customer In customers _
            Where customer.Sports.Count > maxPlayers _
            Select customer.Name
        '
        ' END Listing C-28
        '
        ' ------------------------------------------------------
        For Each c In players
            Console.WriteLine(c)
        Next

    End Sub

End Module

Public Class Customer
    Public Name As String
    Public Sports As String()
    Public Sub New(ByVal name As String)
        Me.Name = name
    End Sub
    Public Sub New()
        Name = "<Unknown>"
    End Sub

End Class

Friend Class _Closure
    Public Sub New()
    End Sub

    Public Sub New(ByVal other As _Closure)
        If (Not other Is Nothing) Then
            Me._maxPlayers = other._maxPlayers
        End If
    End Sub

    Public Function _Lambda_1(ByVal customer As Customer) As Boolean
        Return (customer.Sports.Count > Me._maxPlayers)
    End Function

    Public _maxPlayers As Integer
End Class

