﻿Option Strict On
' Option Infer Off ' See note in Listing C-4 (BeCareful method)

Module LocalTypeInference

    Sub Main()
        'NullableDemo()
        'CoalesceDemo()
        LocalTypeInference(99)
        'BeCareful()
    End Sub

    Sub NullableDemo()
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-1
        '
        ' Nullable types don't work in pre Mar07 CTP
        Dim a As Integer? = 18
        Dim b As Integer? = 24
        Dim c As Integer? = Nothing
        Dim d As Integer?
        d = a + c  ' d = 18 + Nothing = Nothing
        c = a + b  ' c = 18 + 24 = 42 
        '
        ' END Listing C-1
        '
        ' ------------------------------------------------------

        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-2
        '
        ' To be compiled with Option Strict On
        Dim k As Integer? = 16
        'Dim p As Integer = k    ' Compiler error
        'Dim q As Integer = DirectCast(k, Integer) ' Compiler error
        Dim r As Integer = CType(k, Integer)      ' Ok
        '
        ' END Listing C-2
        '
        ' ------------------------------------------------------


        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-3
        '
        ' To be compiled with Option Strict Off
        'Dim k As Integer? = 16
        'Dim p As Integer = k    ' Ok (throws an exception if k is Nothing)
        ''Dim q As Integer = DirectCast(k, Integer) ' Compiler error
        'Dim r As Integer = CType(k, Integer)      ' Ok (throws an exception if k is Nothing)
        ''
        ' END Listing C-3 
        '
        ' ------------------------------------------------------


    End Sub
    Sub CoalesceDemo()
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-4
        '
        Dim temperature As Integer? = 42
        Dim speed As Integer? = Nothing
        Dim firstName As String = "Marco"
        Dim lastName As String = Nothing

        Dim t As Integer = If(temperature, 0) ' t = 42
        Dim s As Integer = If(speed, 0)       ' s = 0
        Dim name As String
        name = If(firstName, "").ToLower() _
               + " " _
               + If(lastName, "").ToUpper()

        Console.WriteLine(t)
        Console.WriteLine(s)
        Console.WriteLine(name)


        '
        ' END Listing C-4
        '
        ' ------------------------------------------------------

        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-5
        '
        Dim num As Integer = 42
        Dim den As Integer = 0
        Dim resultOld As Integer
        Dim resultNew As Integer

        resultNew = If(den <> 0, num \ den, 0)  ' No error
        resultOld = CType(IIf(den <> 0, num \ den, 0), Integer) ' Division by Zero Exception

        Console.WriteLine(resultOld)
        Console.WriteLine(resultNew)

        '
        ' END Listing C-5
        '
        ' ------------------------------------------------------
    End Sub

    Sub LocalTypeInference(ByVal d As Decimal)
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-6
        '
        Dim x = 2.3      ' Double
        Dim y = x        ' Double
        Dim r = x / y    ' Double
        Dim s = "sample" ' String
        Dim l = s.Length ' Integer
        Dim w = d        ' Decimal
        ' Dim o            ' Object

        '
        ' END Listing C-6
        '
        ' ------------------------------------------------------

        Console.WriteLine(x.GetType().ToString())
        Console.WriteLine(y.GetType().ToString())
        Console.WriteLine(r.GetType().ToString())
        Console.WriteLine(s.GetType().ToString())
        Console.WriteLine(l.GetType().ToString())
        Console.WriteLine(w.GetType().ToString())
        ' Console.WriteLine(o.GetType().ToString())
    End Sub

    ' ------------------------------------------------------
    '
    ' BEGIN Listing C-7
    '
    Sub BeCareful()
        ' Use Option Infer Off to avoid an exception in this code
        ' Option Infer Off is useful with Option Strict Off to maintain compatibility
        ' with code written for previous versions of Visual Basic

        'Dim a = 10
        'a = "Hello"
        'Console.WriteLine(a)
    End Sub
    '
    ' END Listing C-7
    '
    ' ------------------------------------------------------

End Module
