﻿' ------------------------------------------------------
'
' BEGIN Listing C-29
'
Partial Class DemoPartial

    Private _Name As String
    Property Name() As String
        Get
            Return _Name
        End Get
        Set(ByVal value As String)
            Dim good As Boolean = True
            OnNameValidation(good)
            If Not good Then
                Exit Property
            End If
            _Name = value
            OnNameChanged()
        End Set
    End Property

    ' Definition of the partial method signature.
    Partial Private Sub OnNameChanged()
    End Sub

    ' Definition of the partial method signature.
    Partial Private Sub OnNameValidation(ByVal goodValidation As Boolean)

    End Sub

End Class
'
' END Listing C-29
'
' ------------------------------------------------------


' ------------------------------------------------------
'
' BEGIN Listing C-30
'
Partial Class DemoPartial ' Partial here is optional
    Private Sub OnNameChanged()
        Console.WriteLine("Name is changed to {0}", Name)
    End Sub
End Class
'
' END Listing C-30
'
' ------------------------------------------------------

Module PartialMethods

    Sub Main()
        Dim a = New DemoPartial
        a.Name = "Marco"
    End Sub

End Module
