﻿Class Customer
    Public Orders As Order()
    Public IdCustomer As Integer

End Class
Class Order
    Public IdOrder As Integer

End Class
Module QueryExpressions
    ' ------------------------------------------------------
    '
    ' BEGIN Listing C-22
    '

    Dim customers() = MakeArray( _
        New With {.Name = "Marco", .Discount = 4.5}, _
        New With {.Name = "Paolo", .Discount = 3.0}, _
        New With {.Name = "Tom", .Discount = 3.5} _
    )

    Function MakeArray(Of T)(ByVal ParamArray params As T()) As T()
        Return params
    End Function
    '
    ' END Listing C-22 (continue...)
    '
    ' ------------------------------------------------------

    Sub Demo_22()
        Console.WriteLine("----------------------------------")
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-22
        '

        Dim query = _
            From c In customers _
            Where c.Discount > 3 _
            Select c.Name, Perc = c.Discount / 100

        '
        ' END Listing C-22
        '
        ' ------------------------------------------------------

        For Each x In query
            Console.WriteLine(x)
        Next

    End Sub
    Sub Demo_24()
        Console.WriteLine("----------------------------------")
        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-24
        '


        Dim query = _
            From c In customers _
            Where c.Discount > 0 _
            Order By c.Discount _
            Select c.Name, Perc = c.Discount / 100


        '
        ' END Listing C-24
        '
        ' ------------------------------------------------------

        ' Warning - this throws an exception in Beta 2 - check if this is a bug that will be fixed!
        For Each x In query
            Console.WriteLine(x)
        Next

    End Sub
    Sub Demo_25()
        Console.WriteLine("----------------------------------")


        ' ------------------------------------------------------
        '
        ' BEGIN Listing C-25
        '
        Dim query = _
            From c In customers _
            Where c.Discount > 3 _
            Select c.Name, Perc = c.Discount / 100 _
            Order By Perc             ' Line added in Listing C-25

        '
        ' END Listing C-25
        '
        ' ------------------------------------------------------

        For Each x In query
            Console.WriteLine(x)
        Next

    End Sub
    Sub Main()
        Demo_22()
        '
        ' NOTE for Listing C-23
        '
        ' The C# code in the book is illustrative only. That code is not present in sample code
        '

        Demo_24()
        Demo_25()

    End Sub

End Module

' some other test code

'Dim customers2() = { _
'    New With {.Name = "Marco", .Discount = 4.5}, _
'    New With {.Name = "Tom", .Discount = 3.5}, _
'    New With {.Name = "Tom", .Discount = 5} _
'}
'Dim query32 = _
'    From c1 In customers _
'    Join c2 In customers2 _
'    On c1.Name Equals c2.Name _
'    Select r = New With {c1.Name, c2.Discount, .D2 = c1.Discount}

'Dim query33 = _
'    From c1 In customers, c2 In customers2 _
'    Where c1.Name = c2.Name _
'    Select r = New With {c1.Name, c2.Discount, .D2 = c1.Discount}

'        For Each x In query32
'            Console.WriteLine(x)
'        Next
'        For Each x In query33
'            Console.WriteLine(x)
'        Next

'Sub test()
'    Dim o1 As Order = New Order With {.IdOrder = 1}
'    Dim o2 As Order = New Order With {.IdOrder = 2}
'    Dim o3 As Order = New Order With {.IdOrder = 3}
'    Dim o4 As Order = New Order With {.IdOrder = 4}
'    Dim o5 As Order = New Order With {.IdOrder = 5}
'    Dim o6 As Order = New Order With {.IdOrder = 6}
'    Dim oa1() As Order = {o1, o2, o3}
'    Dim oa2() As Order = {o4, o5, o6}
'    Dim c1 As Customer = New Customer With {.IdCustomer = 1, .Orders = oa1}
'    Dim c2 As Customer = New Customer With {.IdCustomer = 2, .Orders = oa2}
'    Dim customers() As Customer = {c1, c2, c1}
'    Console.WriteLine(c1)
'    Console.WriteLine(c2)

'    Dim expr = _
'        From c In customers _
'        Aggregate order In c.Orders _
'        Into OrdersCount = Count() _
'        Select New With {c.IdCustomer, OrdersCount}
'    Dim expr2 = _
'        From c In customers _
'        Select New With {c.IdCustomer, .OrdersCount = c.Orders.Count()}


'    Dim query2 = _
'        From c In customers, o In c.Orders _
'        Select o
'    For Each x In expr
'        Console.WriteLine("---")

'        Console.WriteLine(x)
'    Next

'    Dim expr1 = _
'    From c In customers _
'    Group By c.IdCustomer _
'    Into CountryCustomers = Group

'    For Each customerGroup In expr1
'        Console.WriteLine("Country: {0}", customerGroup.IdCustomer)
'        For Each customer In customerGroup.CountryCustomers
'            Console.WriteLine(customer.IdCustomer)
'        Next
'    Next

'End Sub

