﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.Linq.WCF.LinqToSQL.NorthwindModel;
using System.Data.Linq;

namespace DevLeap.Linq.WCF.LinqToSQL.Biz
{
    public class CustomerBiz
    {
        private NorthwindModel.NorthwindDataContext getDataContext()
        {
            NorthwindDataContext northwind = new NorthwindDataContext();
            northwind.DeferredLoadingEnabled = false;
            northwind.ObjectTrackingEnabled = true;

            return (northwind);
        }

        public Customer GetCustomer(String customerID)
        {
            // Enforce security checks
            // TBD...

            // Enforce validation rules
            // TBD...

            // Execute the request
            var customer =
                getDataContext().Customers.Single(c => c.CustomerID == customerID);

            return (customer);
        }

        public Customer UpdateCustomer(Customer customer)
        {
            NorthwindDataContext northwind = getDataContext();
            northwind.Customers.Attach(customer, true);
            northwind.SubmitChanges();
            return(customer);
        }

        public Customer AddCustomer(Customer customer)
        {
            NorthwindDataContext northwind = getDataContext();
            northwind.Customers.Add(customer);
            northwind.SubmitChanges();
            return (customer);
        }

        public Boolean DeleteCustomer(Customer customer)
        {
            NorthwindDataContext northwind = getDataContext();
            northwind.Customers.Attach(customer);
            northwind.Customers.Remove(customer);
            northwind.SubmitChanges();
            return (true);
        }
    }
}






















public static class CustomerExtender
{
    public static void Remove(this Table<Customer> table, Customer customer)
    {
        table.DeleteOnSubmit(customer);
    }

    public static void Add(this Table<Customer> table, Customer customer)
    {
        table.InsertOnSubmit(customer);
    }
}