﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using DevLeap.Linq.WCF.LinqToSQL.Contracts;
using DevLeap.Linq.WCF.LinqToSQL.NorthwindModel;

namespace DevLeap.Linq.WCF.LinqToSQL.ConsumerByFactory
{
    class Program
    {
        static void Main(string[] args)
        {
            ChannelFactory<ICustomerService> factory =
                new ChannelFactory<ICustomerService>("NetTcpBinding_ICustomerService");

            ICustomerService channel = factory.CreateChannel();

            try
            {
                var customer =
                    channel.GetCustomer(new CustomerSelector { CustomerID = "ALFKI" });

                Console.WriteLine("Customer {0} has country: {1}",
                    customer.CustomerID, customer.Country);

                Console.WriteLine("Press ENTER to change customer country");
                Console.ReadLine();

                customer.Country = "Italy";
                customer = channel.UpdateCustomer(customer);

                Console.WriteLine("Customer {0} now has country: {1}",
                    customer.CustomerID, customer.Country);

                Console.WriteLine("Press ENTER to change back customer country");
                Console.ReadLine();

                customer.Country = "Germany";
                customer = channel.UpdateCustomer(customer);

                Console.WriteLine("Customer {0} now has country: {1}",
                    customer.CustomerID, customer.Country);

                Console.WriteLine("Press ENTER to insert a new customer");
                Console.ReadLine();

                Customer newCustomer = new Customer
                {
                    CustomerID = "PAOLO",
                    ContactName = "Paolo Pialorsi",
                    CompanyName = "DevLeap"
                };

                newCustomer = channel.AddCustomer(newCustomer);

                Console.WriteLine("New customer inserted");

                Console.WriteLine("Press ENTER to delete the new customer");
                Console.ReadLine();

                DeletionResult result = channel.DeleteCustomer(newCustomer);
                Console.WriteLine("Deletion result: {0}", result.Result);
            }
            finally
            {
                if (((ICommunicationObject)channel).State != CommunicationState.Closed)
                    ((ICommunicationObject)channel).Close();
            }
        }
    }
}
