﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.Linq.WCF.LinqToSQL.ConsumerByWsdl.CustomerServiceReference;
using System.ServiceModel;

namespace DevLeap.Linq.WCF.LinqToSQL.ConsumerByWsdl
{
    class Program
    {
        static void Main(string[] args)
        {
            CustomerServiceReference.CustomerServiceClient proxy =
                new CustomerServiceReference.CustomerServiceClient("WSHttpBinding_ICustomerService");

            try
            {
                var customer =
                    proxy.GetCustomer(new CustomerSelector { CustomerID = "ALFKI" });

                Console.WriteLine("Customer {0} has country: {1}",
                    customer.CustomerID, customer.Country);

                Console.WriteLine("Press ENTER to change customer country");
                Console.ReadLine();

                customer.Country = "Italy";
                customer = proxy.UpdateCustomer(customer);

                Console.WriteLine("Customer {0} now has country: {1}",
                    customer.CustomerID, customer.Country);

                Console.WriteLine("Press ENTER to change back customer country");
                Console.ReadLine();

                customer.Country = "Germany";
                customer = proxy.UpdateCustomer(customer);

                Console.WriteLine("Customer {0} now has country: {1}",
                    customer.CustomerID, customer.Country);

                Console.WriteLine("Press ENTER to insert a new customer");
                Console.ReadLine();

                Customer newCustomer = new Customer
                {
                    CustomerID = "PAOLO",
                    ContactName = "Paolo Pialorsi",
                    CompanyName = "DevLeap"
                };

                newCustomer = proxy.AddCustomer(newCustomer);

                Console.WriteLine("New customer inserted");

                Console.WriteLine("Press ENTER to delete the new customer");
                Console.ReadLine();

                DeletionResult result = proxy.DeleteCustomer(newCustomer);
                Console.WriteLine("Deletion result: {0}", result.Result);
            }
            finally
            {
                if (((ICommunicationObject)proxy).State != CommunicationState.Closed)
                    ((ICommunicationObject)proxy).Close();
            }
        }
    }
}
