﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace DevLeap.Linq.WCF.Orders.Contracts.DataContract
{
    /// <summary>
    /// This class describes the DataContract for the order type
    /// This a shortened version of what can be generated using SVCUTIL.EXE
    /// 
    /// In the schemas.devleap.com.Order.cs you can find the real autogenerated
    /// code file
    /// </summary>
    [DataContract(Namespace = "http://schemas.devleap.com/Order")]
    public class Order
    {
        [DataMember(IsRequired = true)]
        public int Id { get; set; }
        [DataMember(IsRequired = true, Order = 1)]
        public decimal Amount { get; set; }
        [DataMember(IsRequired = true, EmitDefaultValue = false, Order = 2)]
        public string CustomerCode { get; set; }
    }
}
