﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using DCServices = DevLeap.Linq.WCF.Orders.Services.DataContract;
using SRServices = DevLeap.Linq.WCF.Orders.Services.Serializable;
using DCContracts = DevLeap.Linq.WCF.Orders.Contracts.DataContract;
using SRContracts = DevLeap.Linq.WCF.Orders.Contracts.Serializable;

namespace DevLeap.Linq.WCF.Orders.SelfHost
{
    class Program
    {
        static void Main(string[] args)
        {
            // This piece of code activates a ServiceHost by code
            // to publish the Serializable Ordering Service
            using (ServiceHost host = new ServiceHost(typeof(SRServices.OrderService)))
            {
                Console.WriteLine("Starting SRServices.OrderService...");
                host.AddServiceEndpoint(
                    typeof(SRContracts.IOrderService),
                    new WSHttpBinding(),
                    "http://localhost:8000/OrderService");

                host.Open();

                Console.WriteLine("Host listening ...");
                Console.WriteLine("Start \"DevLeap.Linq.WCF.Orders.ConsumerByFactory\" to consume it");
                Console.WriteLine("Press ENTER when you have finished...");
                Console.ReadLine();
                Console.WriteLine("Closing current service...");
            }

            // This piece of code activates a ServiceHost by .config
            // to publish the DataContract Ordering Service with 
            // its metadata (see app.config file for further details)
            using (ServiceHost host = new ServiceHost(typeof(DCServices.OrderService)))
            {
                Console.WriteLine("Starting DCServices.OrderService...");
                host.Open();

                Console.WriteLine("Host listening ...");
                Console.WriteLine("Start \"DevLeap.Linq.WCF.Orders.ConsumerByWsdl\" to consume it");
                Console.WriteLine("Press ENTER when you have finished...");
                Console.ReadLine();
                Console.WriteLine("Closing current service...");
            }
        }
    }
}
