﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DevLeap.Linq.Web.DataModel
{
    /// <summary>
    /// Listing 16-23
    /// </summary>
    public class Customer
    {
        public Int32 CustomerID { get; set; }

        public String FullName { get; set; }

        public List<Order> Orders { get; set; }
    }

    public class Order 
    {
        public Int32 OrderID { get; set; }

        public Int32 CustomerID { get; set; }

        public Decimal EuroAmount { get; set; }
    }

    /// <summary>
    /// Listing 16-24
    /// </summary>
    public class CustomerManager
    {
        public CustomerManager()
        {
            this.Customers = new List<Customer> {
                new Customer { CustomerID = 1, FullName = "Paolo Pialorsi", 
                    Orders = new List<Order> {
                        new Order { OrderID = 1, CustomerID = 1, EuroAmount = 100},
                        new Order { OrderID = 2, CustomerID = 1, EuroAmount = 200}
                    }
                },
                new Customer { CustomerID = 2, FullName = "Marco Russo", 
                    Orders = new List<Order> {
                        new Order { OrderID = 3, CustomerID = 2, EuroAmount = 150},
                        new Order { OrderID = 4, CustomerID = 2, EuroAmount = 250},
                        new Order { OrderID = 5, CustomerID = 2, EuroAmount = 130},
                        new Order { OrderID = 6, CustomerID = 2, EuroAmount = 220}
                    }
                },
                new Customer { CustomerID = 3, FullName = "Andrea Pialorsi", 
                    Orders = new List<Order> {
                        new Order { OrderID = 7, CustomerID = 3, EuroAmount = 1500},
                        new Order { OrderID = 8, CustomerID = 3, EuroAmount = 2500}
                    }
                }
            };
        }

        public List<Customer> Customers { get; set; }

        public List<Customer> GetCustomers()
        {
            return (this.Customers);
        }
    }
}
