﻿
using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Collections.Generic;

public partial class Listing16_28 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            loadData();
        }
    }

    private void loadData()
    {
        NorthwindDataContext dc = new NorthwindDataContext();

        var query =
            from c in dc.Customers
            // where c.Country == "Italy"
            select new
            {
                c.CustomerID,
                c.ContactName,
                c.CompanyName,
                c.Country
            };

        customersGrid.DataSource = query;
        customersGrid.DataBind();
    }

    /// <summary>
    /// Listing 16-30
    /// </summary>
    protected void UpdateCustomerInstance(String customerID, 
        String contactName, String country, String companyName)
    {
        NorthwindDataContext dc = new NorthwindDataContext();

        Customer customer = dc.Customers.First(c => c.CustomerID == customerID);
        if (customer != null)
        {
            customer.ContactName = contactName;
            customer.Country = country;
            customer.CompanyName = companyName;
        }

        dc.SubmitChanges();
    }

    /// <summary>
    /// Listing 16-31
    /// </summary>
    protected void AttachAndUpdateCustomerInstance(
        String originalCustomerID, String originalContactName, 
        String originalCountry, String originalCompanyName,
        String customerID, String contactName, 
        String country, String companyName)
    {
        NorthwindDataContext dc = new NorthwindDataContext();

        Customer original = new Customer();
        original.CustomerID = originalCustomerID;
        original.ContactName = originalContactName;
        original.Country = originalCountry;
        original.CompanyName = originalCompanyName;

        Customer actual = new Customer();
        actual.CustomerID = customerID;
        actual.ContactName = contactName;
        actual.Country = country;
        actual.CompanyName = companyName;

        dc.Customers.Attach(actual, original);

        dc.SubmitChanges();
    }

    protected void customersGrid_RowEditing(Object source, GridViewEditEventArgs e)
    {
        customersGrid.EditIndex = e.NewEditIndex;
        loadData();
    }

    protected void customersGrid_RowCancelingEdit(Object source, GridViewCancelEditEventArgs e)
    {
        customersGrid.EditIndex = -1;
        loadData();
    }

    protected void customersGrid_RowUpdating(Object source, GridViewUpdateEventArgs e)
    {
        GridViewRow row = customersGrid.Rows[e.RowIndex];
        if (row != null)
        {
            TextBox customerId = row.Cells[1].Controls[0] as TextBox;
            TextBox contactName = row.Cells[2].Controls[0] as TextBox;
            TextBox country = row.Cells[3].Controls[0] as TextBox;
            TextBox companyName = row.Cells[4].Controls[0] as TextBox;

            //// Emulating the retrieval of customer data from ViewState
            //// It will fail for concurrency check when invoked
            //AttachAndUpdateCustomerInstance(
            //    customerId.Text, "", "", "",
            //    customerId.Text,
            //    contactName.Text,
            //    companyName.Text,
            //    country.Text);

            UpdateCustomerInstance(
                customerId.Text,
                contactName.Text,
                companyName.Text,
                country.Text);
        }
        customersGrid.EditIndex = -1;
        loadData();
    }
}
